package b4a.game.helper;

import com.google.android.gms.games.Player;
import com.google.android.gms.games.achievement.Achievement;

import android.database.CharArrayBuffer;
import android.net.Uri;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.ShortName;

@ShortName(value = "gAchievement")
public class AchievementWrapper implements Achievement {
	Achievement me;
	
	public final static int STATE_HIDDEN = Achievement.STATE_HIDDEN;
	public final static int STATE_REVEALED	= Achievement.STATE_REVEALED;
	public final static int STATE_UNLOCKED	= Achievement.STATE_UNLOCKED;
	public final static int TYPE_INCREMENTAL = Achievement.TYPE_INCREMENTAL;
	public final static int TYPE_STANDARD	= Achievement.TYPE_STANDARD;
	
	
	public AchievementWrapper(){
		me = null;
	}
	
	@Hide
	public AchievementWrapper(Achievement a){
		me = a;
	}
	
	@Override
	public String getAchievementId() {
		return me.getAchievementId();
	}

	@Override
	public int getCurrentSteps() {
		return me.getCurrentSteps();
	}

	@Override
	public String getDescription() {
		return me.getDescription();
	}
	
	@Hide
	@Override
	public void getDescription(CharArrayBuffer arg0) {
		
	}

	@Override
	public String getFormattedCurrentSteps() {
		return me.getFormattedCurrentSteps();
	}

	@Hide
	@Override
	public void getFormattedCurrentSteps(CharArrayBuffer arg0) {
		
		
	}

	@Override
	public String getFormattedTotalSteps() {
		return me.getFormattedTotalSteps();
	}

	@Hide
	@Override
	public void getFormattedTotalSteps(CharArrayBuffer arg0) {
		
	}

	@Override
	public long getLastUpdatedTimestamp() {
		return me.getLastUpdatedTimestamp();
	}

	@Override
	public String getName() {
		return me.getName();
	}
	
	@Hide
	@Override
	public void getName(CharArrayBuffer arg0) {
		
	}
	
	@Hide
	@Override
	public Player getPlayer() {
		return me.getPlayer();
	}
	
	public PlayerWrapper getPlayerObject(){
		PlayerWrapper pw = new PlayerWrapper();
		return pw.setPlayerWrapper(me.getPlayer());
	}

	@Hide
	@Override
	public Uri getRevealedImageUri() {
		return null;
	}

	@Override
	public int getState() {
		return me.getState();
	}

	@Override
	public int getTotalSteps() {
		return me.getTotalSteps();
	}

	@Override
	public int getType() {
		return me.getType();
	}
	
	@Hide
	@Override
	public Uri getUnlockedImageUri() {
		return null;
	}

}
