package b4a.game.helper;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.KeyStore.LoadStoreParameter;

import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Permissions;
import anywheresoftware.b4a.BA.ShortName;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.IntentSender.SendIntentException;
import android.os.Bundle;
import android.os.ParcelFileDescriptor;
import android.preference.PreferenceManager.OnActivityResultListener;
import android.util.Log;
import android.view.Gravity;
import android.widget.Toast;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.objects.collections.List;
import b4a.game.helper.GameHelper.GameHelperListener;



import com.google.android.gms.appstate.AppStateClient;
import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GooglePlayServicesClient;
import com.google.android.gms.common.GooglePlayServicesUtil;
import com.google.android.gms.common.Scopes;
import com.google.android.gms.games.Game;
import com.google.android.gms.games.GameBuffer;
import com.google.android.gms.games.GamesClient;
import com.google.android.gms.games.OnGamesLoadedListener;
import com.google.android.gms.games.OnPlayersLoadedListener;
import com.google.android.gms.games.OnSignOutCompleteListener;
import com.google.android.gms.games.Player;
import com.google.android.gms.games.PlayerBuffer;
import com.google.android.gms.games.RealTimeSocket;
import com.google.android.gms.games.achievement.Achievement;
import com.google.android.gms.games.achievement.AchievementBuffer;
import com.google.android.gms.games.achievement.OnAchievementsLoadedListener;
import com.google.android.gms.games.leaderboard.Leaderboard;
import com.google.android.gms.games.leaderboard.LeaderboardBuffer;
import com.google.android.gms.games.leaderboard.LeaderboardScore;
import com.google.android.gms.games.leaderboard.LeaderboardScoreBuffer;
import com.google.android.gms.games.leaderboard.OnLeaderboardMetadataLoadedListener;
import com.google.android.gms.games.leaderboard.OnLeaderboardScoresLoadedListener;
import com.google.android.gms.games.leaderboard.OnScoreSubmittedListener;
import com.google.android.gms.games.leaderboard.SubmitScoreResult;
import com.google.android.gms.games.multiplayer.Invitation;
import com.google.android.gms.games.multiplayer.InvitationBuffer;
import com.google.android.gms.games.multiplayer.OnInvitationsLoadedListener;
import com.google.android.gms.games.multiplayer.realtime.Room;
import com.google.android.gms.games.multiplayer.realtime.RoomConfig;
import com.google.android.gms.games.multiplayer.realtime.RoomUpdateListener;
import com.google.android.gms.plus.PlusClient;


@ShortName("gGameClient")
@Events(values = {"OnGamesLoaded (listgGames as List)",
		"OnPlayersLoaded (listgPlayers as List)",
		"OnLeaderboardMetadataLoaded (listgLeaderboards as List)",
		"OnScoreSubmitted (statusCode as int, ScoreResult as gSubmitScoreResult)",
		"OnLeaderboardScoresLoaded (listgLeaderboards as List, listgLeaderboardScores as List)", 
		"OnAchievementsLoaded (listAchievements as List)"})
public class GameClientWrapper implements OnAchievementsLoadedListener, OnGamesLoadedListener,
		OnPlayersLoadedListener, RealTimeSocket, OnLeaderboardMetadataLoadedListener,
		OnLeaderboardScoresLoadedListener, OnScoreSubmittedListener
{
	@Hide
    protected GamesClient me;
    private BA mBA;
    protected String eventName;
    
    String TAG = "GameClientWrapper";
    
    public final static String EXTRA_EXCLUSIVE_BIT_MASK = GamesClient.EXTRA_EXCLUSIVE_BIT_MASK;
	public final static String EXTRA_INVITATION = GamesClient.EXTRA_INVITATION;
	public final static String EXTRA_MAX_AUTOMATCH_PLAYERS = GamesClient.EXTRA_MAX_AUTOMATCH_PLAYERS;
	public final static String EXTRA_MIN_AUTOMATCH_PLAYERS = GamesClient.EXTRA_MIN_AUTOMATCH_PLAYERS;
	public final static String EXTRA_PLAYERS = GamesClient.EXTRA_PLAYERS;
	public final static String EXTRA_ROOM = GamesClient.EXTRA_ROOM;
	public final static int MAX_RELIABLE_MESSAGE_LEN = GamesClient.MAX_RELIABLE_MESSAGE_LEN;
	public final static int MAX_UNRELIABLE_MESSAGE_LEN = GamesClient.MAX_UNRELIABLE_MESSAGE_LEN;
	public final static int NOTIFICATION_TYPE_INVITATION = GamesClient.NOTIFICATION_TYPE_INVITATION;
	public final static int NOTIFICATION_TYPES_ALL = GamesClient.NOTIFICATION_TYPES_ALL;
	public final static int NOTIFICATION_TYPES_MULTIPLAYER  = GamesClient.NOTIFICATION_TYPES_MULTIPLAYER;
	public final static int STATUS_ACHIEVEMENT_NOT_INCREMENTAL = GamesClient.STATUS_ACHIEVEMENT_NOT_INCREMENTAL;
	public final static int STATUS_ACHIEVEMENT_UNKNOWN = GamesClient.STATUS_ACHIEVEMENT_UNKNOWN;
	public final static int STATUS_ACHIEVEMENT_UNLOCK_FAILURE = GamesClient.STATUS_ACHIEVEMENT_UNLOCK_FAILURE;
	public final static int STATUS_ACHIEVEMENT_UNLOCKED = GamesClient.STATUS_ACHIEVEMENT_UNLOCKED;
	public final static int STATUS_CLIENT_RECONNECT_REQUIRED = GamesClient.STATUS_CLIENT_RECONNECT_REQUIRED;
	public final static int STATUS_INTERNAL_ERROR  = GamesClient.STATUS_INTERNAL_ERROR;
	public final static int STATUS_INVALID_REAL_TIME_ROOM_ID  = GamesClient.STATUS_INVALID_REAL_TIME_ROOM_ID;
	public final static int STATUS_LICENSE_CHECK_FAILED  = GamesClient.STATUS_LICENSE_CHECK_FAILED;
	public final static int STATUS_MULTIPLAYER_ERROR_CREATION_NOT_ALLOWED  = GamesClient.STATUS_MULTIPLAYER_ERROR_CREATION_NOT_ALLOWED;
	public final static int STATUS_MULTIPLAYER_ERROR_NOT_TRUSTED_TESTER  = GamesClient.STATUS_MULTIPLAYER_ERROR_NOT_TRUSTED_TESTER;
	public final static int STATUS_NETWORK_ERROR_NO_DATA = GamesClient.STATUS_NETWORK_ERROR_NO_DATA;
	public final static int STATUS_NETWORK_ERROR_OPERATION_DEFERRED = GamesClient.STATUS_NETWORK_ERROR_OPERATION_DEFERRED;
	public final static int STATUS_NETWORK_ERROR_OPERATION_FAILED = GamesClient.STATUS_NETWORK_ERROR_OPERATION_FAILED;
	public final static int STATUS_NETWORK_ERROR_STALE_DATA = GamesClient.STATUS_NETWORK_ERROR_STALE_DATA;
	public final static int STATUS_OK = GamesClient.STATUS_OK;
	public final static int STATUS_PARTICIPANT_NOT_CONNECTED = GamesClient.STATUS_PARTICIPANT_NOT_CONNECTED;
	public final static int STATUS_REAL_TIME_CONNECTION_FAILED = GamesClient.STATUS_REAL_TIME_CONNECTION_FAILED;
	public final static int STATUS_REAL_TIME_INACTIVE_ROOM = GamesClient.STATUS_REAL_TIME_INACTIVE_ROOM;
	public final static int STATUS_REAL_TIME_MESSAGE_FAILED = GamesClient.STATUS_REAL_TIME_MESSAGE_FAILED;
	public final static int STATUS_REAL_TIME_MESSAGE_SEND_FAILED = GamesClient.STATUS_REAL_TIME_MESSAGE_SEND_FAILED;
	public final static int STATUS_REAL_TIME_ROOM_NOT_JOINED = GamesClient.STATUS_REAL_TIME_ROOM_NOT_JOINED;

			
	
	
	
	
	/**
	 * Used to assign the GameClient returned by gGameServices.getGamesClient
	 */
	public GameClientWrapper() {
		me = null;
		mBA = null;
	}
	

	@Hide
	public GameClientWrapper(GameHelper helper, BA ba, String en){
		me = helper.getGamesClient();
		mBA = ba;
		debugLog("initialize event GCW");
		eventName = en.toLowerCase(ba.cul);
	}
	
	
	public GameClientWrapper getgGameClient(){
		return this;
	}
	
	
	public void clearAllNotifications() {
		me.clearAllNotifications();
	}
	
	public void clearAllNotifications(int notificationTypes){
		me.clearNotifications(notificationTypes);
	}
	
	public void connect(){
		me.connect();
	}
	
	
	public void disconnect(){
		me.disconnect();
	}
	
	
	public boolean equals(Object o){
		return me.equals(o); 
	}
	
	@Hide
	public Intent getAchievementsIntent(){
		return me.getAchievementsIntent();
	}
	@Hide
	public Intent getAllLeaderboardsIntent(){
		return me.getAllLeaderboardsIntent();
	}
	
	public String getAppId(){
		return me.getAppId();
	}
	
	/** 
	 * Had to name this getMyClass vs getClass, as unable to override final
	 */
	public Class<? extends Object> getMyClass() {
		return me.getClass();
	}
	
	
	public String getCurrentAccountName() {
		return me.getCurrentAccountName();
	}

	public PlayerWrapper getCurrentPlayer(){
		
		PlayerWrapper pw = new PlayerWrapper();
		return pw.getCurrentPlayer(me);
		
	}
	
	public String getCurrentPlayerId(){
		return me.getCurrentPlayerId();
	}
	
	@Hide
	public Intent getInvitationInboxIntent(){
		return me.getInvitationInboxIntent();
	}
	
	@Hide
	public Intent getLeaderboardIntent(String leaderboardId){
		return me.getLeaderboardIntent(leaderboardId);	
	}
	
	/**
	 * RealTimeSocketWrapper Still needing to figure out ParcelFileDecriptor
	 * not used by me yet, so not developed!
	 */
	public RealTimeSocketWrapper getRealTimeSocketForParticipant(String roomId, String participantId){
		RealTimeSocket rts;
		rts = me.getRealTimeSocketForParticipant(roomId, participantId);
		RealTimeSocketWrapper rtw = new RealTimeSocketWrapper();
		rtw.setRealTimeSocket(rts);
		return rtw;
		}
	
	@Hide
	public Intent getRealTimeWaitingRoomIntent(Room room, int minParticipantsToStart){
		return me.getRealTimeWaitingRoomIntent(room, minParticipantsToStart);
	}
	
	@Hide
	public Intent getSelectPlayersIntent(int minPlayers, int maxPlayers ){
		return me.getSelectPlayersIntent(minPlayers, maxPlayers);
	}
	
	@Hide
	public Intent getSettingsIntent(){
		return me.getSettingsIntent();
	}
	
	public int hashCode(){
		return me.hashCode();
	}
	public void incrementAchievement(String id, int numSteps){
		me.incrementAchievement(id, numSteps);
	}
	
	public boolean isConnected() {
		return me.isConnected();
	}
	
	public boolean isConnecting() {
		return me.isConnecting();
	}
	
	@Hide
	public void joinRoom(RoomConfig config) {
		me.joinRoom(config);
	}

	@Hide
	public void leaveRoom(RoomUpdateListener listener, String roomId) {
		me.leaveRoom(listener, roomId);
	}
	
	
	public void reconnect() {
		me.reconnect();
	}
	
	public void revealAchievment(String id) {
		 me.revealAchievement(id);
	}
	
	/**
	 * Sets gravity on where login popups appear
	 * 
	 */
	public void setGravityForPopups(int gravity) {
		me.setGravityForPopups(gravity);
	}
	
	public void setUseNewPlayerNotificationsFirstParty(boolean newPlayerStyle) {
		me.setUseNewPlayerNotificationsFirstParty(newPlayerStyle);

	}
	
	public void signOut() {
		me.signOut();
	}
	
	
	public void submitScore(String leaderboardId, long score) {
		me.submitScore(leaderboardId, score);
	}
	
	/**
	 * 
	 * requires the OnScoreSubmitted listener
	 */
	public void submitScoreImmediate(String leaderboardId, long score){
		me.submitScoreImmediate(this, leaderboardId, score);
	}
	
	
	public String toString() {
		return me.toString();
	}
	
	
	public void unlockAchievement(String id) {
		me.unlockAchievement(id);
	}
	
	
	public void unregisterInvitationListener() {
		me.unregisterInvitationListener();
	}

		
	/*
	 * requires the _OnAchievementsLoaded(listgAchievements as List)
	 */
	public void loadAchievements() {
		me.loadAchievements(this);
	}
	
	
	@Hide
	public void onAchievementsLoaded(int status, AchievementBuffer arg1) {
		List list1 = new List();
		if (status == GamesClient.STATUS_OK) {
			list1.Initialize();
			for (Achievement ach: arg1){
				AchievementWrapper aw = new AchievementWrapper(ach);
				//Toast.makeText(mBA.context, "Loading " + aw.getName(), Toast.LENGTH_SHORT).show();
				list1.Add(aw);
			}
			//Toast.makeText(mBA.context, "onAchievementsLoaded: ", Toast.LENGTH_SHORT).show();
			mBA.raiseEvent(this, eventName + "_onachievementsloaded", list1);
			return;
		}
		list1 = null;
		mBA.raiseEvent(this, eventName + "_onachievementsloaded", (Object[]) null);
	}
	
	/*
	 * requires the _OnGamessLoaded(listgGames as List)
	 */
	public void loadGame(){
		me.loadGame(this);
	}
	
	@Hide
	@Override
	public void onGamesLoaded(int status, GameBuffer arg1) {
		List list1 = new List();
		if (status == GamesClient.STATUS_OK) {
			list1.Initialize();
			for( Game g : arg1) {
				GameWrapper gw = new GameWrapper();
				gw.setObject(g);
				list1.Add(gw);
			}
			mBA.raiseEvent(this, eventName + "_ongamessloaded", list1);
			return;
			
		}
		mBA.raiseEvent(this, eventName + "_ongamessloaded", (Object[]) null);
	}
	
	/**
	 * Asynchronously loads the profile for the requested player ID. 
	 * Requires the OnPlayersLoaded listener
	 * If disconnect() is called before the result is ready it will not be delivered.
	 */
	public void loadPlayer(String playerId) {
		me.loadPlayer(this, playerId);
	}
	
	
	@Hide
	@Override
	public void onPlayersLoaded(int status, PlayerBuffer arg1) {
		List list1 = new List();
		if (status == GamesClient.STATUS_OK) {
			list1.Initialize();
			for( Player p : arg1) {
				PlayerWrapper pw = new PlayerWrapper(p);
				list1.Add(pw);
			}
			mBA.raiseEvent(this, eventName + "_onplayersloaded", list1);
			return;
			
		}
		mBA.raiseEvent(this, eventName + "_onplayersloaded", (Object[]) null);
	}

	
	/**
	 * Requires the OnLeaderboardMetadataLoaded listener
	 * That listener will return a list of gLeaderboards or null, if none
	 */
	public void loadLeaderboardMetadata(){
		me.loadLeaderboardMetadata(this);
	}
	
	/**
	 * Requires the OnLeaderboardMetadataLoaded listener
	 * That listener will return a list of gLeaderboards or null, if none
	 */
	public void loadLeaderboardMetadata(String leaderboardId){
		me.loadLeaderboardMetadata(this, leaderboardId);
	}
	
	@Hide
	@Override
	public void onLeaderboardMetadataLoaded(int status, LeaderboardBuffer arg1) {
		List list1 = new List();
		if (status == GamesClient.STATUS_OK) {
			list1.Initialize();
			for (Leaderboard lb : arg1){
				LeaderboardWrapper lbw = new LeaderboardWrapper();
				lbw.setObject(lb);
				list1.Add(lbw);
			}
			mBA.raiseEvent(this, eventName + "_onleaderboardmetadataloaded", list1);
			return;
			
		}
		mBA.raiseEvent(this, eventName + "_onleaderboardmetadataloaded", (Object[]) null);
		
	}
	
	/**
	 * Requires the OnLeaderboardScoresLoaded listener, which will return two Lists
	 * listgLeaderboard and listgLeaderboardScore
	 */
	public void loadPlayerCenteredScores(String leaderboardId, int span, int leaderboardCollection, int maxResults){
		me.loadPlayerCenteredScores(this, leaderboardId, span, leaderboardCollection, maxResults);
	}
	public void loadTopScores(String leaderboardId, int span, int leaderboardCollection, int maxResults, boolean forceReload){
		me.loadTopScores(this, leaderboardId, span, leaderboardCollection, maxResults, forceReload);
	}
	public void loadTopScores(String leaderboardId, int span, int leaderboardCollection, int maxResults){
		me.loadTopScores(this, leaderboardId, span, leaderboardCollection, maxResults);
	}
	
	@Hide
	@Override
	public void onLeaderboardScoresLoaded(int status, LeaderboardBuffer arg1, LeaderboardScoreBuffer arg2) {
		List list1 = new List();
		List list2 = new List();
		if (status == GamesClient.STATUS_OK) {
			list1.Initialize();
			list2.Initialize();
			for (Leaderboard l : arg1) {
				LeaderboardWrapper lw = new LeaderboardWrapper();
				lw.setObject(l);
				list1.Add(lw);
			}
			
			for (LeaderboardScore ls : arg2){
				LeaderboardScoreWrapper lsw = new LeaderboardScoreWrapper(ls);
				list2.Add(lsw);
			}
			
			mBA.raiseEvent(this, eventName + "_onleaderboardscoresloaded", list1, list2);
			return;
		}
		list1 = null;
		list2 = null;
		mBA.raiseEvent(this, eventName + "_onleaderboardscoresloaded", list1, list2);
	}
	
	private void debugLog(String message){
		Log.d(TAG, message);
	}
	 
	
	@Override
	public void close() throws IOException {
		// TODO Auto-generated method stub
		
	}
	
	/**
	 * not implemented
	 */
	@Override
	public InputStream getInputStream() throws IOException {
		// TODO Auto-generated method stub
		return null;
	}

	/**
	 * not implemented
	 */
	@Override
	public OutputStream getOutputStream() throws IOException {
		// TODO Auto-generated method stub
		return null;
	}

	/**
	 * not implemented
	 */
	@Override
	public ParcelFileDescriptor getParcelFileDescriptor() throws IOException {
		// TODO Auto-generated method stub
		return null;
	}

	/**
	 * not implemented
	 */
	@Override
	public boolean isClosed() {
		// TODO Auto-generated method stub
		return false;
	}


	@Override
	public void onScoreSubmitted(int arg0, SubmitScoreResult arg1) {
		SubmitScoreResultWrapper ssrw = new SubmitScoreResultWrapper(arg1);
		mBA.raiseEvent(this, eventName + "_onscoresubmitted", arg0, ssrw);
	}




	
	
	
}
