package b4a.game.helper;


import com.google.android.gms.common.SignInButton;

import android.content.Intent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Toast;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.keywords.constants.Colors;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.objects.collections.Map;

@ShortName(value = "gSignInButton")
@Events(values = { "_Click" })
public class GoogleButton extends ViewWrapper<SignInButton>  {
	
    @Override
    @Hide
    public void innerInitialize(final BA ba, final String eventName, boolean keepOldObject) {
        if (!keepOldObject)
        	setObject(new SignInButton(ba.context));
        super.innerInitialize(ba, eventName, true);
        if (ba.subExists(eventName + "_click")) {
        	getObject().setOnClickListener(new OnClickListener() {

				@Override
				public void onClick(View arg0) {
					ba.raiseEvent(this, eventName + "_click");
				}
        		
        	});
           
        }
    }
    /**
	 * Sets color scheme.
	 * Valid values are ColorLight, Color_Dark
	 */
	public void setColorScheme(int colorScheme){
		getObject().setColorScheme(colorScheme);
	}
	
	
	/**
	 * Set the size of the button to use. The color scheme will remain unchanged.
	 * Valid values are SIZE_STANDARD, SIZE_WIDE, or SIZE_ICON_ONLY. 
	 */
	public void setSize(int buttonSize){
		getObject().setSize(buttonSize);
	}
    
	public int SIZE_ICON_ONLY(){
		return getObject().SIZE_ICON_ONLY;
	}
	
	public int SIZE_STANDARD(){
		return getObject().SIZE_STANDARD;
	}
	
	public int SIZE_WIDE(){
		return getObject().SIZE_WIDE;
	}
	
	public int COLOR_DARK(){
		return getObject().COLOR_DARK;
	}
    
	public int COLOR_LIGHT(){
		return getObject().COLOR_LIGHT;
	}
    
 
	
	
	
	
	
	
	/** 
	 * All below was done before I knew about extending ViewWrapper... so much easier when you know the tools!
	 */
	
	
	
//	private BA ba;
//	private String eventName;
//	private SignInButton signInButtonView;
//	private SignInButton me;
//	
//	public static final int SIZE_ICON_ONLY = SignInButton.SIZE_ICON_ONLY;
//	public static final int SIZE_STANDARD = SignInButton.SIZE_STANDARD;
//	public static final int SIZE_WIDE = SignInButton.SIZE_WIDE;
//	
//	public static final int COLOR_DARK = SignInButton.COLOR_DARK;
//	public static final int COLOR_LIGHT = SignInButton.COLOR_LIGHT;
//	
//	
//	
//	@Hide
//	public void _initialize(BA ba, Object activityClass, String EventName) {
//        this.eventName = EventName.toLowerCase(BA.cul);
//        this.ba = ba;
//        
//    }
//	
//	public void initialize(BA ba, String EventName) {
//        _initialize(ba, null, EventName);
//        
//    }
//	
//	
//	
//	 //programmatically add view
//    public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height, int Size) {
//        signInButtonView = new SignInButton(ba.context);
//        signInButtonView.setSize(Size);
//        Parent.addView(signInButtonView, new BALayout.LayoutParams(left, top, width, height));
//        signInButtonView.setOnClickListener(new OnClickListener() {
//			@Override
//			public void onClick(View arg0) {
//				ba.raiseEvent(this, eventName + "_click");
//			} 
//        });
//    }
//    
//    
//	@Override
//	 //this method cannot be hidden.
//    public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
//        ViewGroup vg = (ViewGroup) base.getObject().getParent();
//        base.RemoveView();
//        AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight(), SIZE_STANDARD );
//    }
//	
//	/**
//	 * Set the size of the button to use. The color scheme will remain unchanged.
//	 * @Param buttonSize The size of the button to display. Valid values are SIZE_STANDARD, SIZE_WIDE, or SIZE_ICON_ONLY. 
//	 */
//	public void setSize(int buttonSize){
//		signInButtonView.setSize(buttonSize);
//	}
//	
//	/**
//	 * Set the color scheme of the button to use. The size will remain unchanged.
//	 * colorScheme 	The color scheme to use for the button. Valid values are COLOR_DARK or COLOR_LIGHT. 
//	 */
//	public void setColorScheme(int colorScheme){
//		
//	}
//	
//	public void setEnabled(boolean enabled){
//		signInButtonView.setEnabled(enabled);
//	}
//	
//	public boolean isEnabled(){
//		return signInButtonView.isEnabled();
//	}
//	
////	public int getLeft(){
////		return signInButtonView.getLeft();
////	}
//	
////	public void setLeft(@Pixel int left){
////		signInButtonView.setLayoutParams(new BALayout.LayoutParams(left, this.signInButtonView.getTop(), 100, 100));
////		
////	}
//	/**
//	 * To set view parameters at run time.  All the get functions return 0, so went with this method.
//	 */
//	public void setLayout(@Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
//		signInButtonView.setLayoutParams(new BALayout.LayoutParams(left, top, width, height));
//		Toast.makeText(ba.context, Integer.toString(signInButtonView.getWidth()), Toast.LENGTH_SHORT).show();
//	}
//	
////	public int getTop(){
////		return signInButtonView.getTop();
////	}
////	
////	public int getRight(){
////		return signInButtonView.getRight();
////	}
////	
////	public int getBottom(){
////		return signInButtonView.getBottom();
////	}
	
	

	
}
