package b4a.game.helper;

import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.ShortName;

import com.google.android.gms.games.leaderboard.LeaderboardVariant;

@ShortName(value = "gLeaderboardVariant")
public class LeaderboardVariantWrapper implements LeaderboardVariant{
	protected LeaderboardVariant me;
	
//	@Hide
//	public LeaderboardVariantWrapper(){
//		me = null;
//	}
	
	public static final int COLLECTION_PUBLIC = LeaderboardVariant.COLLECTION_PUBLIC;
	public static final int COLLECTION_SOCIAL = LeaderboardVariant.COLLECTION_SOCIAL;
	public static final int NUM_SCORES_UNKNOWN = LeaderboardVariant.NUM_SCORES_UNKNOWN;
	public static final int NUM_TIME_SPANS = LeaderboardVariant.NUM_TIME_SPANS;
	public static final int PLAYER_RANK_UNKNOWN = LeaderboardVariant.PLAYER_RANK_UNKNOWN;
	public static final int PLAYER_SCORE_UNKNOWN = LeaderboardVariant.PLAYER_SCORE_UNKNOWN;
	public static final int TIME_SPAN_ALL_TIME = LeaderboardVariant.TIME_SPAN_ALL_TIME;
	public static final int TIME_SPAN_DAILY = LeaderboardVariant.TIME_SPAN_DAILY;
	public static final int TIME_SPAN_WEEKLY = LeaderboardVariant.TIME_SPAN_WEEKLY;
	
	
	@Hide
	public LeaderboardVariantWrapper(LeaderboardVariant lv){
		me = lv;

	}
	
	@Override
	/**
	 * Retrieves the collection of scores contained by this variant.
	 */
	public int getCollection() {
		return me.getCollection();
	}
	
	/**
	 * Retrieves the viewing player's formatted rank for this variant, if any.
	 */
	@Override
	public String getDisplayPlayerRank() {
		return me.getDisplayPlayerRank();
	}
	
	/**
	 * Retrieves the viewing player's score for this variant, if any
	 */
	@Override
	public String getDisplayPlayerScore() {
		return me.getDisplayPlayerScore();
	}

	/**
	 * Retrieves the total number of scores for this variant.
	 */
	@Override
	public long getNumScores() {
		return me.getNumScores();
	}

	/**
	 * Retrieves the viewing player's rank for this variant, if any
	 */
	@Override
	public long getPlayerRank() {
		return me.getPlayerRank();
	}

	/**
	 * Retrieves the viewing player's score for this variant, if any
	 */
	@Override
	public long getRawPlayerScore() {
		return me.getRawPlayerScore();
	}

	/**
	 * Retrieves the time span that the scores for this variant are drawn from
	 */
	@Override
	public int getTimeSpan() {
		return me.getTimeSpan();
	}

	/**
	 * Get whether or not this variant contains score information for the viewing player or not.
	 */
	@Override
	public boolean hasPlayerInfo() {
		return me.hasPlayerInfo();
	}

}
