package b4a.game.helper;

import android.database.CharArrayBuffer;
import android.net.Uri;
import android.os.Parcel;
import android.os.Parcelable;
import android.widget.ImageView;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.objects.ImageViewWrapper;

import com.google.android.gms.common.images.ImageManager;
import com.google.android.gms.games.Player;
import com.google.android.gms.games.multiplayer.Participant;

@ShortName(value = "gParticipant")
public class ParticipantWrapper implements Participant{
	Participant me;
	public final static int STATUS_DECLINED = Participant.STATUS_DECLINED;
	public final static int STATUS_INVITED = Participant.STATUS_INVITED;
	public final static int STATUS_JOINED = Participant.STATUS_JOINED;
	public final static int STATUS_LEFT = Participant.STATUS_LEFT;
	public final static int CONTENTS_FILE_DESCRIPTOR = Parcelable.CONTENTS_FILE_DESCRIPTOR;
	public final static int PARCELABLE_WRITE_RETURN_VALUE = Parcelable.PARCELABLE_WRITE_RETURN_VALUE;
	
	public void ParticipantWrapper(){
		me = null;
	}
	
	@Hide
	public void ParticpantWrapper(Participant p){
		me = p;
	}
	
	@Hide
	public ParticipantWrapper setParticipant(Participant p){
		me = p;
		return this;
	}
	
	@Override
	public int describeContents() {
		return me.describeContents();
	}

	@Override
	public void writeToParcel(Parcel arg0, int arg1) {
		me.writeToParcel(arg0, arg1);
		
	}

	@Override
	public Participant freeze() {
		return me.freeze();
	}
	

	@Override
	public String getClientAddress() {
		return me.getClientAddress();
	}

	@Override
	public String getDisplayName() {
		return me.getDisplayName();
	}

	@Hide
	@Override
	public Uri getHiResImageUri() {
		return me.getHiResImageUri();
	}
	
	@Hide
	@Override
	public Uri getIconImageUri() {
		return me.getHiResImageUri();
	}
	
	@Override
	public String getParticipantId() {
		return me.getParticipantId();
	}
	@Hide
	@Override
	public Player getPlayer() {
		return me.getPlayer();
	}
	
	public PlayerWrapper getPlayerWrapper(){
		PlayerWrapper pw = new PlayerWrapper();
		return pw.setPlayerWrapper(me.getPlayer());
	}

	@Override
	public int getStatus() {
		return me.getStatus();
	}

	@Override
	public boolean isConnectedToRoom() {
		return me.isConnectedToRoom();
	}
	@Hide
	@Override
	public void getDisplayName(CharArrayBuffer dataOut) {
		me.getDisplayName(dataOut);
		
	}
	
	/**
	 * Pass ImageView to asynchrously load the image. 
	 * If no image, then nothing will be passed to ImageView
	 */
	public void loadHiResImageUri(final BA ba, ImageViewWrapper ivw) {
			loadUriIntoImageview(me.getHiResImageUri(), ivw.getObject(), ba);
	}
	
	/**
	 * Pass ImageView to asynchrously load the image
	 * If no image, then nothing will be passed to ImageView
	 */
	public void loadIconImage(final BA ba, ImageViewWrapper ivw) {
			loadUriIntoImageview(me.getIconImageUri(), ivw.getObject(), ba);
	}
	
	//for use by all the load uri methods
	private void loadUriIntoImageview(Uri uri, ImageView iv, BA ba){
		if (uri == null){ return;}
		ImageManager im = ImageManager.create(ba.context);
		im.loadImage(iv, uri);
	}

}
