package b4a.game.helper;



import android.database.CharArrayBuffer;
import android.net.Uri;

import android.os.Parcelable;
import android.util.Log;
import android.widget.ImageView;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.objects.ImageViewWrapper;

import com.google.android.gms.common.images.ImageManager;
import com.google.android.gms.games.GamesClient;
import com.google.android.gms.games.Player;



@ShortName("gPlayer")


public class PlayerWrapper {
	private Player me;
	public static final int PARCELABLE_WRITE_RETURN_VALUE = Parcelable.PARCELABLE_WRITE_RETURN_VALUE;
	public static final int CONTENTS_FILE_DESCRIPTOR = Parcelable.CONTENTS_FILE_DESCRIPTOR;
	
	public PlayerWrapper(){
		
	}
	@Hide
	public PlayerWrapper(Player p){
		me=p;
	}
	
	protected PlayerWrapper getCurrentPlayer(GamesClient gc){
		if (gc == null) return null;
		me = gc.getCurrentPlayer();
		return this;
	}
	
	public PlayerWrapper getCurrentPlayer(GameClientWrapper gameClient){
		return gameClient.getCurrentPlayer();
	}
	
	protected PlayerWrapper setPlayerWrapper(Player p){
		me = p;
		return this;
	}
	
	public int describeContents() {
		return me.describeContents();
	}
	
	@Override
	public boolean equals(Object o) {
		return me.equals(o);
	}
	
	
	public PlayerWrapper freeze() {
		PlayerWrapper pw = new PlayerWrapper();
		pw.me = me.freeze();
		return pw;
	}
	

	public String getDisplayName() {
		return me.getDisplayName();
	}
	
	
	public void getDisplayName(CharArrayBuffer arg0) {
		me.getDisplayName(arg0);
	}
	
	/**
	 * Pass ImageView to asynchrously load the image
	 */
	public void loadHiResImageUri(final BA ba, ImageViewWrapper ivw) {
		if (me.hasHiResImage()){
			loadUriIntoImageview(me.getHiResImageUri(), ivw.getObject(), ba);
		}
	}
	
	/**
	 * Pass ImageView to asynchrously load the image
	 */
	public void loadIconImage(final BA ba, ImageViewWrapper ivw) {
		if (me.hasIconImage()){
			loadUriIntoImageview(me.getIconImageUri(), ivw.getObject(), ba);
		}
	}
	
	//for use by all the load uri methods
	private void loadUriIntoImageview(Uri uri, ImageView iv, BA ba){
		ImageManager im = ImageManager.create(ba.context);
		im.loadImage(iv, uri);
	}
	
	
	
	public String getPlayerId() {
		return me.getPlayerId();
	}
	
	
	public long getRetrievedTimestamp() {
		return me.getRetrievedTimestamp();
	}
	
	
	public int hashCode() {
		return me.hashCode();
	}
	
	
	public boolean hasHiResImage() {
		return me.hasHiResImage();
	}
	
	
	public boolean hasIconImage() {
		return me.hasIconImage();
	}
	
	
	public String toString() {
		return me.toString();
	}
	
	private void debugLog(String message){
		Log.d("PlayerWrapper", message);
	}
//	@Override
//	@Hide
//	public void onImageLoaded(Uri arg0, Drawable arg1) {
//		debugLog("got drawable" + arg1.getBounds().toString() + " " + arg0.toString());
//		ImageView iv = new ImageView(mBA.context);
//		mBA.raiseEvent(this, "onthisimageloaded", arg1);
//	//	mBA.raiseEvent(this, "trythis", arg1);
//		//mBA.raiseEventFromUI(this, "trythis", arg1);
//		//mBA.raiseEventFromDifferentThread(this, null, 0,  "GGS_onimageloaded", true, new Object[] {arg1});
//		debugLog("event Raised");
//		
//	}
	


	
}
