package b4a.game.helper;




import java.util.ArrayList;


import com.google.android.gms.games.GamesClient;
import com.google.android.gms.games.multiplayer.Participant;
import com.google.android.gms.games.multiplayer.realtime.RealTimeMessage;
import com.google.android.gms.games.multiplayer.realtime.RealTimeMessageReceivedListener;
import com.google.android.gms.games.multiplayer.realtime.Room;
import com.google.android.gms.games.multiplayer.realtime.RoomConfig;
import com.google.android.gms.games.multiplayer.realtime.RoomConfig.Builder;
import com.google.android.gms.games.multiplayer.realtime.RoomStatusUpdateListener;
import com.google.android.gms.games.multiplayer.realtime.RoomUpdateListener;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.widget.Toast;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.IOnActivityResult;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.objects.collections.List;


@ActivityObject
@ShortName(value = "gRoom")
//@Events(values = { "onJoinedRoom (int statusCode, gRoom room",
//		"onLeftRoom (int statusCode, String roomId)",
//		"onRoomConnected (int statusCode, gRoom room)",
//		"onRoomCreated (object room)",})

public class RoomWrapper{
	private Room me;
	private BA mBA;
	private String eventName;
	private IOnActivityResult ion;
	// Request codes for the UIs that we show with startActivityForResult:
    public final static int RC_SELECT_PLAYERS = 10000;
    public final static int RC_INVITATION_INBOX = 10001;
    public final static int RC_WAITING_ROOM = 10002;
    

    public final static int STATUS_ACTIVE = Room.ROOM_STATUS_ACTIVE;
    public final static int STATUS_AUTO_MATCHING = Room.ROOM_STATUS_AUTO_MATCHING;
    public final static int STATUS_CONNECTING = Room.ROOM_STATUS_CONNECTING;
    public final static int STATUS_INVITING = Room.ROOM_STATUS_INVITING;
    public final static int VARIANT_ANY = Room.ROOM_VARIANT_ANY;
    public final static int STATUS_NULL = 111;
    
    
	private static String TAG = "RoomWrapper";
	
	public RoomWrapper(BA ba) {
		me = null;

		mBA = ba;
	}
	
	public RoomWrapper(){
		me = null;
		mBA = null;
	}
	
	public RoomWrapper(BA ba, Room room){
		mBA = ba;
		me = room;
	}
	
	/**
	 *
	 * 
	 */
	public void initialize(BA ba, String EventName) {
		mBA = ba;
		eventName = EventName.toLowerCase(BA.cul);
	}
	
	
	
	/*
	 * the server timestamp a which the room created
	 */
	public long getCreationTimestamp() {
		return me.getCreationTimestamp();
	}
	
	/*
	 * the ID of the participant that created this Room
	 */
	public String getCreatorId(){
		return me.getCreatorId();
	}
	/*
	 * description of this room
	 */
	public String getDescription(){
		return me.getDescription();
	}
	
	/*
	 * Get the participant ID for a given player. This will only return a non-null ID if the player is actually a participant in the room and that player's identity is visible to the current player. Note that this will always return non-null for the current player.
	 */
	public String getParticipantId(String playerId){
		return me.getParticipantId(playerId);
	}
	/**
	 * The IDs of the participants in this room. These are returned in the participant order of the room. Note that these are not stable across rooms. 
	 */
	public List getParticipantIds(){
		List list1 = new List();
		list1.Initialize();
		for (String str : me.getParticipantIds()){
			list1.Add(str);
		}
		return list1;
	}
	
	
	/*
	 * returns a list of each gParticipant
	 */
	public List getParticipants() {
		List list1 = new List();
		list1.Initialize();
		
		for (Participant p : me.getParticipants()){
			ParticipantWrapper pw = new ParticipantWrapper();
			pw.me = p;
			list1.Add(pw);
		}
		
		return list1;
	}
	/**
	 * Get the status of a participant in a room. Note that the participant ID must correspond to a participant in this room, or this method will throw an exception.
	 * participantId 	Room-local ID of the participant to retrieve status for
	 * Returns The current status of the participant in this room. One of STATUS_INVITED, STATUS_JOINED, STATUS_DECLINED, or STATUS_LEFT.
	 */
	public int getParticipantStatus(String participantId){
		return me.getParticipantStatus(participantId);
	}
	
	/**
	 * Returns current room status
	 */
	public int getStatus(){
		if (me == null) {
			return STATUS_NULL;
		}
		return me.getStatus();
	}
	
//	/**
//	 * requires the _invitePlayersComplete listener, will leave current Activity, and start up new Activity that allows the selection of players to invite
//	 * when complete, will return one Object:
//	 * ArrayList<String> invitees as Object
//	 * use it in the RoomConfig Creation Process
//	 */
//	public void invitePlayers(final BA ba, final GameClientWrapper GCW){
//		if (GCW.me.isConnected()) {
//			Intent i = new Intent(GCW.me.getSelectPlayersIntent(1, 3));
//			
//			ion = new IOnActivityResult() {
//		        @Override
//		        public void ResultArrived(int resultCode, Intent data) {
//		            if (resultCode == Activity.RESULT_OK) {	
//		            	// we got the result from the "select players" UI -- ready to create the room
//		                handleResult(resultCode, data, ba, GCW);
//		                    
//		                    
//		            	
//		            } else {
//		            	 List list1 = null;
//		            	 Toast.makeText(ba.context, "cancelled", Toast.LENGTH_SHORT).show();
//		            	 ba.raiseEvent(this, eventName +"_inviteplayerscomplete", list1);
//		            }
//		        }
//		    };
//		    ba.startActivityForResult(ion, i);
//		}
//		
//	}
//	
//
//	
//	private void handleResult(int resultCode, Intent data, BA ba, final GameClientWrapper GCW) {
//		Log.d(TAG, "Select players UI succeeded.");
//
//        final ArrayList<String> invitees = data.getStringArrayListExtra(GamesClient.EXTRA_PLAYERS);
//        Log.d(TAG, "Invitee count: " + invitees.size());
//        //Toast.makeText(ba.context, "Invitee count: " + invitees.size(), Toast.LENGTH_SHORT).show();
//        // get the automatch criteria
//        Bundle autoMatchCriteria = null;
//        int minAutoMatchPlayers = data.getIntExtra(GamesClient.EXTRA_MIN_AUTOMATCH_PLAYERS, 0);
//        int maxAutoMatchPlayers = data.getIntExtra(GamesClient.EXTRA_MAX_AUTOMATCH_PLAYERS, 0);
//        if (minAutoMatchPlayers > 0 || maxAutoMatchPlayers > 0) {
//            autoMatchCriteria = RoomConfig.createAutoMatchCriteria(
//                    minAutoMatchPlayers, maxAutoMatchPlayers, 0);
//            Log.d(TAG, "Automatch criteria: " + autoMatchCriteria);
//            
//        }
//        
//        ba.raiseEvent(this, eventName +"_inviteplayerscomplete", invitees);
//        Log.d(TAG, "called " + eventName +"_inviteplayerscomplete");
//	}
	
	/*
	 * use this in the listener OnRoomCreate to store the returned room
	 */
	public void setRoom(Room room){
		me = room;
	}
	@Hide
	protected Room getRoom(){
		return me;
	}
	
	// Show the waiting room UI to track the progress of other players as they enter the
    // room and get connected.
    void showWaitingRoom(GameClientWrapper GCW) {


        // minimum number of players required for our game
        final int MIN_PLAYERS = 2;
       // Intent i = GCW.getGameClient().getRealTimeWaitingRoomIntent(room, MIN_PLAYERS);

        // show waiting room UI
       // startActivityForResult(i, RC_WAITING_ROOM);
    }
    
    public void createRoom(GameClientWrapper GCW, RoomConfig rc){
    	GCW.me.createRoom(rc);
    }

//	@Override
//	public void onJoinedRoom(int statusCode, Room room) {
//		// TODO Auto-generated method stub
//		
//	}
//
//	@Override
//	public void onLeftRoom(int statusCode, String roomId) {
//		// TODO Auto-generated method stub
//		
//	}
//
//	@Override
//	public void onRoomConnected(int statusCode, Room room) {
//		// TODO Auto-generated method stub
//		
//	}
//
//	@Override
//	public void onRoomCreated(int statusCode, Room room) {
//		Toast.makeText(mBA.context, "room created", Toast.LENGTH_SHORT).show();
//		
//	}

//	@Override
//	public void onRealTimeMessageReceived(RealTimeMessage arg0) {
//		// TODO Auto-generated method stub
//		
//	}

//	@Override
//	public void onConnectedToRoom(Room arg0) {
//		Toast.makeText(mBA.context, "room connected", Toast.LENGTH_SHORT).show();
//		
//	}
//
//	@Override
//	public void onDisconnectedFromRoom(Room arg0) {
//		// TODO Auto-generated method stub
//		
//	}
//
//	@Override
//	public void onPeerDeclined(Room arg0, java.util.List<String> arg1) {
//		// TODO Auto-generated method stub
//		
//	}
//
//	@Override
//	public void onPeerInvitedToRoom(Room arg0, java.util.List<String> arg1) {
//		// TODO Auto-generated method stub
//		
//	}
//
//	@Override
//	public void onPeerJoined(Room arg0, java.util.List<String> arg1) {
//		// TODO Auto-generated method stub
//		
//	}
//
//	@Override
//	public void onPeerLeft(Room arg0, java.util.List<String> arg1) {
//		// TODO Auto-generated method stub
//		
//	}
//
//	@Override
//	public void onPeersConnected(Room arg0, java.util.List<String> arg1) {
//		// TODO Auto-generated method stub
//		
//	}
//
//	@Override
//	public void onPeersDisconnected(Room arg0, java.util.List<String> arg1) {
//		// TODO Auto-generated method stub
//		
//	}
//
//	@Override
//	public void onRoomAutoMatching(Room arg0) {
//		// TODO Auto-generated method stub
//		
//	}
//
//	@Override
//	public void onRoomConnecting(Room arg0) {
//		// TODO Auto-generated method stub
//		
//	}



}
